/********************************************************
*  AWP Limit script by DLB                              *
*                                                       *
*  Description: Lets you limit how many AWPs each       *
*    player can buy per map. Meant to limit people      *
*    from overusing a very powerful weapon and ruining  *
*    the game for others possibly.                      *
*                                                       *
*  Requires: StatsMe (http://www.olo.counter-strike.pl) *
*                                                       *
*  Website: Http://www.BobDev.com                       *
*  E-mail: Bob@BobDev.com                               *
*														*
*  Edited by Sir Drink a lot:							*
*  - plugin is now only for CS 1.6						*
*  - restrictions added/edited							*
*  - removed admin_awpexploit function					*
********************************************************/

/*
  Admin commands:
    admin_awplimit: Set the limit, -1 disables the script
    admin_awpcheck: Prints list of users' purchase amounts
      (again, use this to check if they have purchased over the command because it keeps counting)

  Public stuff:
    checkawp: prints out purchased AWPs
    say checkawp: same thing
*/


#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[] = "0.8 (edit by SirD.)";

#define ACCESS_RESTRICT 8192
#define ACCESS_CONSOLE 131071


#define MENU_NONE		0
#define MENU_RIFLES     4
#define MENU_PRIMAMMO	6
#define MENU_SECAMMO	7
#define MENU_EQUIPMENT	8
#define MENU_INVALID    9
#define MENU_CANCEL		10
#define MENU_MAIN		11
#define AWP_T	5
#define AWP_CT	6

new g_sb_awplimit = -1;
new g_AwpCount[MAX_PLAYERS];
new g_UserMenuSelected[MAX_PLAYERS];
new g_Money[MAX_PLAYERS];

public plugin_init() {
	plugin_registerinfo("AWP limit script","Lets you limit how many times one person can buy the AWP.",STRING_VERSION);
	
	//admin commands
	plugin_registercmd("admin_awplimit","admin_awplimit",ACCESS_RESTRICT,"admin_awplimit <limit>: Changes the limit for amount of AWP purchases, -1 for no limit.");
	plugin_registercmd("admin_awpcheck","admin_awpcheck",ACCESS_RESTRICT,"admin_awpcheck : Lists the players who have above a 0 purchase record.");
	
	//User command events:
	plugin_registercmd("buy","buy",ACCESS_ALL);
	plugin_registercmd("buyequip","buyequip",ACCESS_ALL);
	plugin_registercmd("menuselect","menuselect",ACCESS_ALL);
	plugin_registercmd("radio1","ClearMenu",ACCESS_ALL);
	plugin_registercmd("radio2","ClearMenu",ACCESS_ALL);
	plugin_registercmd("radio3","ClearMenu",ACCESS_ALL);
	plugin_registercmd("chooseteam","ClearMenu",ACCESS_ALL);
	plugin_registercmd("say","HandleSay",ACCESS_ALL);
	plugin_registercmd("checkawp","CheckAWP",ACCESS_ALL);
	
	//awp buy
	plugin_registercmd("awp","awp",ACCESS_ALL);
	plugin_registercmd("magnum","awp",ACCESS_ALL);

	//Get vault value to save across map changes and stuff
	get_vaultnumdata("admin_awplimit",g_sb_awplimit);
	
	//statsme event
	plugin_registercmd("handle_money","handle_money",ACCESS_CONSOLE);
	exec("sm_reg Money ^"admin_command handle_money^" bd");
	
	return PLUGIN_CONTINUE;
}

//ADMIN COMMANDS
public admin_awplimit(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	//Data[0] means Data isn't empty (usually)
	if (strlen(Data)!=0) {
		g_sb_awplimit = strtonum(Data);
		set_vaultnumdata("admin_awplimit",g_sb_awplimit);
	}
	//Tell the admin what the limit is (does it even if it was empty so it just reports)
	snprintf(Text, MAX_TEXT_LENGTH, "AWP limit is ^"%i^"", g_sb_awplimit);
	messageex(User, Text, print_console);
	return PLUGIN_HANDLED;
}

public admin_awpcheck(HLCommand,HLData,HLUserName,UserIndex) {
	new Text[MAX_TEXT_LENGTH];
	new Player[MAX_NAME_LENGTH];
	new maxplayers=maxplayercount();
	new i;
	selfmessage("** AWP CHECK **");
	selfmessage("* AWPs - PLAYERNAME *");
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Player,MAX_NAME_LENGTH)){
			snprintf(Text,MAX_TEXT_LENGTH,"* %i - %s",g_AwpCount[i],Player);
			selfmessage(Text);
			strinit(Text);
		}
	}
	selfmessage("**************");
	return PLUGIN_HANDLED;
}

//PUBLIC COMMANDS
public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	
	strstripquotes(Data);
	if (streq(Data,"checkawp")) {
		display_awp(User,UserIndex);
	}
	return PLUGIN_CONTINUE;
}

public CheckAWP(HLCommand,HLData,HLUserName,UserIndex) {
	new User[MAX_NAME_LENGTH];
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	display_awp(User,UserIndex);
	return PLUGIN_HANDLED;
}

//STATSME EVENT
public handle_money(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new sUserIndex[MAX_TEXT_LENGTH];
	new sMoney[MAX_TEXT_LENGTH];
	new iUserIndex, iMoney;
	
	if (g_sb_awplimit != -1) {
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		strsplit(Data, " ", sUserIndex, 4, sMoney, 7);
		iUserIndex = strtonum(sUserIndex);
		iMoney = strtonum(sMoney);
		if (iUserIndex == 0){
			return PLUGIN_CONTINUE;
		}
		
		if(playerinfo(iUserIndex,User,MAX_NAME_LENGTH)){
			if (iMoney == (g_Money[iUserIndex] - 4750)){
				if(g_AwpCount[iUserIndex]<g_sb_awplimit){
					g_AwpCount[iUserIndex]+=1;
					display_awp(User,iUserIndex);
				}
			}
			g_Money[iUserIndex] = iMoney;
		}
	}
	return PLUGIN_CONTINUE;
}

//CHECK RESTRICTION
public plugin_connect(HLUserName,HLIP,UserIndex) {
    if (0 < UserIndex < MAX_PLAYERS) {
        g_UserMenuSelected[UserIndex] = MENU_NONE;
        g_AwpCount[UserIndex] = MENU_NONE;
        g_Money[UserIndex] = MENU_NONE;
    }
    return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
    if (0 < UserIndex < MAX_PLAYERS) {
        g_UserMenuSelected[UserIndex] = MENU_NONE;
        g_AwpCount[UserIndex] = MENU_NONE;
        g_Money[UserIndex]= MENU_NONE;
    }
    return PLUGIN_CONTINUE;
}

public buy(HLCommand,HLData,HLUserName,UserIndex){
    g_UserMenuSelected[UserIndex] = MENU_MAIN;
    return PLUGIN_CONTINUE;
}

public buyequip(HLCommand,HLData,HLUserName,UserIndex){
    g_UserMenuSelected[UserIndex] = MENU_EQUIPMENT;
    return PLUGIN_CONTINUE;
}

public ClearMenu(HLCommand,HLData,HLUserName,UserIndex) {
    g_UserMenuSelected[UserIndex] = MENU_NONE;
    return PLUGIN_CONTINUE;
}

public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	if(g_UserMenuSelected[UserIndex] != MENU_NONE){
		new Data[MAX_DATA_LENGTH];
		new User[MAX_NAME_LENGTH];
		new iSelectedNumber;
		new iTeam;
		
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		iSelectedNumber=strtonum(Data);
		
		if(iSelectedNumber == MENU_CANCEL) {
			g_UserMenuSelected[UserIndex] = MENU_NONE;
		}	
		if(g_UserMenuSelected[UserIndex]==MENU_MAIN){
			if(iSelectedNumber == MENU_PRIMAMMO || iSelectedNumber == MENU_SECAMMO || iSelectedNumber == MENU_INVALID) {
				if(getvar("allow_client_exec")) {
					execclient(User,"menuselect 10");
				}
			} else {
				g_UserMenuSelected[UserIndex] = iSelectedNumber;
			}
		}else if(g_UserMenuSelected[UserIndex] == MENU_RIFLES){
			get_userTeam(User,iTeam);
			if(iTeam==1){
				if(iSelectedNumber==AWP_T){
					if(g_AwpCount[UserIndex]>=g_sb_awplimit){
						display_awp(User,UserIndex);
						return PLUGIN_HANDLED;
					}
				}
			}else if(iTeam==2){
				if(iSelectedNumber==AWP_CT){
					if(g_AwpCount[UserIndex]>=g_sb_awplimit){
						display_awp(User,UserIndex);
						return PLUGIN_HANDLED;
					}
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public awp(HLCommand,HLData,HLUserName,UserIndex){
	new User[MAX_NAME_LENGTH];
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if(g_AwpCount[UserIndex]>=g_sb_awplimit){
		display_awp(User,UserIndex);
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

display_awp(User[],UserIndex){
	new Text[MAX_TEXT_LENGTH];
	snprintf(Text,MAX_TEXT_LENGTH,"You have purchased (%i/%i) allowed AWPs.",g_AwpCount[UserIndex],g_sb_awplimit);
	messageex(User,Text,print_chat);
	if(g_AwpCount[UserIndex]>=g_sb_awplimit){
		snprintf(Text,MAX_TEXT_LENGTH,"You are not allowed to buy more AWPs.");
		messageex(User,Text,print_chat);
	}	
}
